<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfErrore ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfErrore
 * @subpackage Arrays
 */
class ArrayOfErrore extends AbstractStructArrayBase
{
    /**
     * The Errore
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\Errore[]
     */
    public $Errore;
    /**
     * Constructor method for ArrayOfErrore
     * @uses ArrayOfErrore::setErrore()
     * @param \StructType\Errore[] $errore
     */
    public function __construct(array $errore = array())
    {
        $this
            ->setErrore($errore);
    }
    /**
     * Get Errore value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\Errore[]|null
     */
    public function getErrore()
    {
        return isset($this->Errore) ? $this->Errore : null;
    }
    /**
     * Set Errore value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\Errore[] $errore
     * @return \ArrayType\ArrayOfErrore
     */
    public function setErrore(array $errore = array())
    {
        foreach ($errore as $arrayOfErroreErroreItem) {
            // validation for constraint: itemType
            if (!$arrayOfErroreErroreItem instanceof \StructType\Errore) {
                throw new \InvalidArgumentException(sprintf('The Errore property can only contain items of \StructType\Errore, "%s" given', is_object($arrayOfErroreErroreItem) ? get_class($arrayOfErroreErroreItem) : gettype($arrayOfErroreErroreItem)), __LINE__);
            }
        }
        if (is_null($errore) || (is_array($errore) && empty($errore))) {
            unset($this->Errore);
        } else {
            $this->Errore = $errore;
        }
        return $this;
    }
    /**
     * Add item to Errore value
     * @throws \InvalidArgumentException
     * @param \StructType\Errore $item
     * @return \ArrayType\ArrayOfErrore
     */
    public function addToErrore(\StructType\Errore $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\Errore) {
            throw new \InvalidArgumentException(sprintf('The Errore property can only contain items of \StructType\Errore, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->Errore[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\Errore|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\Errore|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\Errore|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\Errore|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\Errore|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string Errore
     */
    public function getAttributeName()
    {
        return 'Errore';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfErrore
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
