<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for AvviaTransazionePagamentoSpontaneoRequest StructType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:AvviaTransazionePagamentoSpontaneoRequest
 * @subpackage Structs
 */
class AvviaTransazionePagamentoSpontaneoRequest extends AbstractStructBase
{
    /**
     * The CodiceContratto
     * Meta informations extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $CodiceContratto;
    /**
     * The Delega
     * Meta informations extracted from the WSDL
     * - nillable: true
     * @var \StructType\DelegaF24
     */
    public $Delega;
    /**
     * The IdentificativoChiamante
     * Meta informations extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $IdentificativoChiamante;
    /**
     * The Password
     * Meta informations extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $Password;
    /**
     * The UrlAnnullo
     * Meta informations extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $UrlAnnullo;
    /**
     * The UrlKo
     * Meta informations extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $UrlKo;
    /**
     * The UrlOk
     * Meta informations extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $UrlOk;
    /**
     * Constructor method for AvviaTransazionePagamentoSpontaneoRequest
     * @uses AvviaTransazionePagamentoSpontaneoRequest::setCodiceContratto()
     * @uses AvviaTransazionePagamentoSpontaneoRequest::setDelega()
     * @uses AvviaTransazionePagamentoSpontaneoRequest::setIdentificativoChiamante()
     * @uses AvviaTransazionePagamentoSpontaneoRequest::setPassword()
     * @uses AvviaTransazionePagamentoSpontaneoRequest::setUrlAnnullo()
     * @uses AvviaTransazionePagamentoSpontaneoRequest::setUrlKo()
     * @uses AvviaTransazionePagamentoSpontaneoRequest::setUrlOk()
     * @param string $codiceContratto
     * @param \StructType\DelegaF24 $delega
     * @param string $identificativoChiamante
     * @param string $password
     * @param string $urlAnnullo
     * @param string $urlKo
     * @param string $urlOk
     */
    public function __construct($codiceContratto = null, \StructType\DelegaF24 $delega = null, $identificativoChiamante = null, $password = null, $urlAnnullo = null, $urlKo = null, $urlOk = null)
    {
        $this
            ->setCodiceContratto($codiceContratto)
            ->setDelega($delega)
            ->setIdentificativoChiamante($identificativoChiamante)
            ->setPassword($password)
            ->setUrlAnnullo($urlAnnullo)
            ->setUrlKo($urlKo)
            ->setUrlOk($urlOk);
    }
    /**
     * Get CodiceContratto value
     * @return string|null
     */
    public function getCodiceContratto()
    {
        return $this->CodiceContratto;
    }
    /**
     * Set CodiceContratto value
     * @param string $codiceContratto
     * @return \StructType\AvviaTransazionePagamentoSpontaneoRequest
     */
    public function setCodiceContratto($codiceContratto = null)
    {
        // validation for constraint: string
        if (!is_null($codiceContratto) && !is_string($codiceContratto)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($codiceContratto)), __LINE__);
        }
        $this->CodiceContratto = $codiceContratto;
        return $this;
    }
    /**
     * Get Delega value
     * @return \StructType\DelegaF24|null
     */
    public function getDelega()
    {
        return $this->Delega;
    }
    /**
     * Set Delega value
     * @param \StructType\DelegaF24 $delega
     * @return \StructType\AvviaTransazionePagamentoSpontaneoRequest
     */
    public function setDelega(\StructType\DelegaF24 $delega = null)
    {
        $this->Delega = $delega;
        return $this;
    }
    /**
     * Get IdentificativoChiamante value
     * @return string|null
     */
    public function getIdentificativoChiamante()
    {
        return $this->IdentificativoChiamante;
    }
    /**
     * Set IdentificativoChiamante value
     * @param string $identificativoChiamante
     * @return \StructType\AvviaTransazionePagamentoSpontaneoRequest
     */
    public function setIdentificativoChiamante($identificativoChiamante = null)
    {
        // validation for constraint: string
        if (!is_null($identificativoChiamante) && !is_string($identificativoChiamante)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($identificativoChiamante)), __LINE__);
        }
        $this->IdentificativoChiamante = $identificativoChiamante;
        return $this;
    }
    /**
     * Get Password value
     * @return string|null
     */
    public function getPassword()
    {
        return $this->Password;
    }
    /**
     * Set Password value
     * @param string $password
     * @return \StructType\AvviaTransazionePagamentoSpontaneoRequest
     */
    public function setPassword($password = null)
    {
        // validation for constraint: string
        if (!is_null($password) && !is_string($password)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($password)), __LINE__);
        }
        $this->Password = $password;
        return $this;
    }
    /**
     * Get UrlAnnullo value
     * @return string|null
     */
    public function getUrlAnnullo()
    {
        return $this->UrlAnnullo;
    }
    /**
     * Set UrlAnnullo value
     * @param string $urlAnnullo
     * @return \StructType\AvviaTransazionePagamentoSpontaneoRequest
     */
    public function setUrlAnnullo($urlAnnullo = null)
    {
        // validation for constraint: string
        if (!is_null($urlAnnullo) && !is_string($urlAnnullo)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($urlAnnullo)), __LINE__);
        }
        $this->UrlAnnullo = $urlAnnullo;
        return $this;
    }
    /**
     * Get UrlKo value
     * @return string|null
     */
    public function getUrlKo()
    {
        return $this->UrlKo;
    }
    /**
     * Set UrlKo value
     * @param string $urlKo
     * @return \StructType\AvviaTransazionePagamentoSpontaneoRequest
     */
    public function setUrlKo($urlKo = null)
    {
        // validation for constraint: string
        if (!is_null($urlKo) && !is_string($urlKo)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($urlKo)), __LINE__);
        }
        $this->UrlKo = $urlKo;
        return $this;
    }
    /**
     * Get UrlOk value
     * @return string|null
     */
    public function getUrlOk()
    {
        return $this->UrlOk;
    }
    /**
     * Set UrlOk value
     * @param string $urlOk
     * @return \StructType\AvviaTransazionePagamentoSpontaneoRequest
     */
    public function setUrlOk($urlOk = null)
    {
        // validation for constraint: string
        if (!is_null($urlOk) && !is_string($urlOk)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($urlOk)), __LINE__);
        }
        $this->UrlOk = $urlOk;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\AvviaTransazionePagamentoSpontaneoRequest
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
