<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for RecuperaDatiDelegaRequest StructType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:RecuperaDatiDelegaRequest
 * @subpackage Structs
 */
class RecuperaDatiDelegaRequest extends AbstractStructBase
{
    /**
     * The CodiceContratto
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $CodiceContratto;
    /**
     * The IdentificativoChiamante
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $IdentificativoChiamante;
    /**
     * The IdentificativoDelega
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $IdentificativoDelega;
    /**
     * The Password
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Password;
    /**
     * Constructor method for RecuperaDatiDelegaRequest
     * @uses RecuperaDatiDelegaRequest::setCodiceContratto()
     * @uses RecuperaDatiDelegaRequest::setIdentificativoChiamante()
     * @uses RecuperaDatiDelegaRequest::setIdentificativoDelega()
     * @uses RecuperaDatiDelegaRequest::setPassword()
     * @param string $codiceContratto
     * @param string $identificativoChiamante
     * @param string $identificativoDelega
     * @param string $password
     */
    public function __construct($codiceContratto = null, $identificativoChiamante = null, $identificativoDelega = null, $password = null)
    {
        $this
            ->setCodiceContratto($codiceContratto)
            ->setIdentificativoChiamante($identificativoChiamante)
            ->setIdentificativoDelega($identificativoDelega)
            ->setPassword($password);
    }
    /**
     * Get CodiceContratto value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getCodiceContratto()
    {
        return isset($this->CodiceContratto) ? $this->CodiceContratto : null;
    }
    /**
     * Set CodiceContratto value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $codiceContratto
     * @return \StructType\RecuperaDatiDelegaRequest
     */
    public function setCodiceContratto($codiceContratto = null)
    {
        // validation for constraint: string
        if (!is_null($codiceContratto) && !is_string($codiceContratto)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($codiceContratto)), __LINE__);
        }
        if (is_null($codiceContratto) || (is_array($codiceContratto) && empty($codiceContratto))) {
            unset($this->CodiceContratto);
        } else {
            $this->CodiceContratto = $codiceContratto;
        }
        return $this;
    }
    /**
     * Get IdentificativoChiamante value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getIdentificativoChiamante()
    {
        return isset($this->IdentificativoChiamante) ? $this->IdentificativoChiamante : null;
    }
    /**
     * Set IdentificativoChiamante value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $identificativoChiamante
     * @return \StructType\RecuperaDatiDelegaRequest
     */
    public function setIdentificativoChiamante($identificativoChiamante = null)
    {
        // validation for constraint: string
        if (!is_null($identificativoChiamante) && !is_string($identificativoChiamante)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($identificativoChiamante)), __LINE__);
        }
        if (is_null($identificativoChiamante) || (is_array($identificativoChiamante) && empty($identificativoChiamante))) {
            unset($this->IdentificativoChiamante);
        } else {
            $this->IdentificativoChiamante = $identificativoChiamante;
        }
        return $this;
    }
    /**
     * Get IdentificativoDelega value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getIdentificativoDelega()
    {
        return isset($this->IdentificativoDelega) ? $this->IdentificativoDelega : null;
    }
    /**
     * Set IdentificativoDelega value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $identificativoDelega
     * @return \StructType\RecuperaDatiDelegaRequest
     */
    public function setIdentificativoDelega($identificativoDelega = null)
    {
        // validation for constraint: string
        if (!is_null($identificativoDelega) && !is_string($identificativoDelega)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($identificativoDelega)), __LINE__);
        }
        if (is_null($identificativoDelega) || (is_array($identificativoDelega) && empty($identificativoDelega))) {
            unset($this->IdentificativoDelega);
        } else {
            $this->IdentificativoDelega = $identificativoDelega;
        }
        return $this;
    }
    /**
     * Get Password value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getPassword()
    {
        return isset($this->Password) ? $this->Password : null;
    }
    /**
     * Set Password value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $password
     * @return \StructType\RecuperaDatiDelegaRequest
     */
    public function setPassword($password = null)
    {
        // validation for constraint: string
        if (!is_null($password) && !is_string($password)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($password)), __LINE__);
        }
        if (is_null($password) || (is_array($password) && empty($password))) {
            unset($this->Password);
        } else {
            $this->Password = $password;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\RecuperaDatiDelegaRequest
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
